package com.zegoggles.smssync.service;

import android.content.Intent;

import com.github.axet.smsgate.R;

public enum BackupType {
    BROADCAST_INTENT(R.string.source_3rd_party),
    INCOMING(R.string.source_incoming),
    REGULAR(R.string.source_regular),
    REPLY(R.string.source_reply),
    UNKNOWN(R.string.source_unknown),
    MANUAL(R.string.source_manual);

    public final int resId;

    BackupType(int resId) {
        this.resId = resId;
    }

    public static final String EXTRA = "com.zegoggles.smssync.BackupTypeAsString";

    public static BackupType fromIntent(Intent intent) {
        if (intent.hasExtra(EXTRA)) {
            final String name = intent.getStringExtra(EXTRA);
            for (BackupType type : values()) {
                if (type.name().equals(name)) {
                    return type;
                }
            }
            return UNKNOWN;
        } else {
            return UNKNOWN;
        }
    }

    public boolean isBackground() {
        return this != MANUAL;
    }
}
